#!/usr/bin/env python3
# automome-web.py
# automome - the OTTish AUTOMEME clone
# Copyright (C) 2014  Penguin Development
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# This file is a raptorish and dirty CGI wrapper for automome.py
import os
import random
import sys

import automome

random.seed()
n = 1
memes = []
idx = -1
indices = False

qs = os.getenv('QUERY_STRING')
if qs:
    qs = qs.split('&')
    for q in qs:
        if q.startswith(('c=', 'categories=')):
            q = q[q.index('=') + 1:]
            if 'a' in q:
                memes += automome.memes_automeme_molpish
            if 'o' in q:
                memes += automome.memes_other_molpish
            if 'm' in q:
                memes += automome.memes_meta_molpish
            if 'A' in q:
                memes += automome.memes_automeme_unmolpish
            if 'O' in q:
                memes += automome.memes_other_unmolpish
        elif q.startswith('n='):
            try:
                n = int(q[2:])
            except:
                pass
        elif q == 'i':
            indices = True
        elif q.startswith('l='):
            try:
                idx = int(q[2:])
            except:
                idx = -1
                pass

if n < 1:
    n = 1
if n > 100:
    n = 100
if len(memes) == 0:
    memes = automome.memes_automeme_molpish + automome.memes_other_molpish + \
            automome.memes_meta_molpish

print('Content-type:text/plain;charset=utf-8\nContent-language:en-GB\n')
sys.stdout.flush()

if idx >= len(memes):
    if indices:
        sys.stdout.buffer.write(b'-1190 ')
    sys.stdout.buffer.write(b'ENJOY YOUR EASTER EGG.\n')
    idx = -1

for i in range(n):
    j = random.randrange(len(memes)) if idx < 0 else idx
    if indices:
        sys.stdout.buffer.write('{} '.format(j).encode('UTF-8'))
    sys.stdout.buffer.write(str(memes[j]).encode('UTF-8') + b'\n')
